diff --git a/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java b/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
index ecafc696f..da45714df 100644
--- a/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
+++ b/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
@@ -1,9 +1,10 @@
 package net.minecraft.core.world.pathfinder;
 
+import net.minecraft.core.block.DoorBlock;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockDoor;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.WorldSource;
 
@@ -11,13 +12,13 @@ public class PathFinder
 {
     private final WorldSource worldSource;
     private final BinaryHeap openSet;
-    private final IdHashMap<Node> closedSet;
+    private final IntHashMap<Node> closedSet;
     private final Node[] neighbors;
 
     public PathFinder(WorldSource worldSource)
     {
         openSet = new BinaryHeap();
-        closedSet = new IdHashMap<>();
+        closedSet = new IntHashMap<>();
         neighbors = new Node[32];
         this.worldSource = worldSource;
     }
@@ -36,8 +37,8 @@ public class PathFinder
     {
         openSet.clear();
         closedSet.clear();
-        Node pathpoint = getNode(MathHelper.floor_double(entity.bb.minX), MathHelper.floor_double(entity.bb.minY), MathHelper.floor_double(entity.bb.minZ));
-        Node pathpoint1 = getNode(MathHelper.floor_double(xt - (double)(entity.bbWidth / 2.0F)), MathHelper.floor_double(yt), MathHelper.floor_double(zt - (double)(entity.bbWidth / 2.0F)));
+        Node pathpoint = getNode(MathHelper.floor(entity.bb.minX), MathHelper.floor(entity.bb.minY), MathHelper.floor(entity.bb.minZ));
+        Node pathpoint1 = getNode(MathHelper.floor(xt - (double)(entity.bbWidth / 2.0F)), MathHelper.floor(yt), MathHelper.floor(zt - (double)(entity.bbWidth / 2.0F)));
         Node pathpoint2 = new Node(MathHelper.floor_float(entity.bbWidth + 1.0F), MathHelper.floor_float(entity.bbHeight + 1.0F), MathHelper.floor_float(entity.bbWidth + 1.0F));
         Path pathentity = findPath(entity, pathpoint, pathpoint1, pathpoint2, distance);
         return pathentity;
@@ -172,7 +173,7 @@ public class PathFinder
         if(pathpoint == null)
         {
             pathpoint = new Node(x, y, z);
-            closedSet.add(l, pathpoint);
+            closedSet.put(l, pathpoint);
         }
         return pathpoint;
     }
@@ -190,10 +191,10 @@ public class PathFinder
                     {
                         continue;
                     }
-                    if(Block.blocksList[k1] instanceof BlockDoor)
+                    if(Block.blocksList[k1] instanceof DoorBlock)
                     {
                         int l1 = worldSource.getBlockMetadata(x1, y1, z1);
-                        if(!BlockDoor.isOpen(l1))
+                        if(!DoorBlock.isOpen(l1))
                         {
                             return 0;
                         }
diff --git a/src/main/java/net/minecraft/core/world/save/DimensionData.java b/src/main/java/net/minecraft/core/world/save/DimensionData.java
index 1123f25bd..6cebaa0c3 100644
--- a/src/main/java/net/minecraft/core/world/save/DimensionData.java
+++ b/src/main/java/net/minecraft/core/world/save/DimensionData.java
@@ -9,6 +9,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
 
 import java.io.File;
 import java.io.IOException;
@@ -137,7 +138,7 @@ public class DimensionData
 
     public Weather getCurrentWeather()
     {
-        return Weather.getWeather(weatherCurrentId);
+        return Weathers.getWeather(weatherCurrentId);
     }
 
     public void setCurrentWeather(Weather weather)
@@ -148,7 +149,7 @@ public class DimensionData
     public Weather getNextWeather()
     {
         if (weatherNextId == -1) return null;
-        return Weather.getWeather(weatherNextId);
+        return Weathers.getWeather(weatherNextId);
     }
 
     public void setNextWeather(Weather weather)
diff --git a/src/main/java/net/minecraft/core/world/save/LevelData.java b/src/main/java/net/minecraft/core/world/save/LevelData.java
index e6eb9de10..e8b96c26b 100644
--- a/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.save;
 
 import net.minecraft.core.data.gamerule.GameRuleCollection;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.NbtIo;
 
@@ -11,7 +11,7 @@ import java.nio.file.Files;
 import java.util.List;
 
 // Referenced classes of package net.minecraft.src:
-//            NBTTagCompound, EntityPlayer
+//            NBTTagCompound, Player
 
 public class LevelData
 {
@@ -100,10 +100,10 @@ public class LevelData
         return nbttagcompound;
     }
 
-    public CompoundTag getNBTTagCompoundWithPlayer(List<EntityPlayer> list)
+    public CompoundTag getNBTTagCompoundWithPlayer(List<Player> list)
     {
         CompoundTag nbttagcompound = new CompoundTag();
-        EntityPlayer entityplayer = null;
+        Player entityplayer = null;
         CompoundTag nbttagcompound1 = null;
         if(list.size() > 0)
         {
diff --git a/src/main/java/net/minecraft/core/world/save/LevelStorage.java b/src/main/java/net/minecraft/core/world/save/LevelStorage.java
index 017c560c8..9cf4b34df 100644
--- a/src/main/java/net/minecraft/core/world/save/LevelStorage.java
+++ b/src/main/java/net/minecraft/core/world/save/LevelStorage.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.save;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
@@ -38,7 +38,7 @@ public interface LevelStorage
 	 * @param levelData The level data to save.
 	 * @param playerList A list of players whose data should be saved.
 	 */
-	void saveLevelDataAndPlayerData(LevelData levelData, List<EntityPlayer> playerList);
+	void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList);
 
 	/**
 	 * Saves the level data.
diff --git a/src/main/java/net/minecraft/core/world/save/PlayerIO.java b/src/main/java/net/minecraft/core/world/save/PlayerIO.java
index ebe0a700d..64496b8ce 100644
--- a/src/main/java/net/minecraft/core/world/save/PlayerIO.java
+++ b/src/main/java/net/minecraft/core/world/save/PlayerIO.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.world.save;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 
 public interface PlayerIO
 {
 
-    void save(EntityPlayer player);
+    void save(Player player);
 
-    void load(EntityPlayer player);
+    void load(Player player);
 }
diff --git a/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java b/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
index cee6cd4ee..cfb4e6793 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.save;
 
 import net.minecraft.core.MinecraftException;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
@@ -115,7 +115,7 @@ public abstract class SaveHandlerBase implements LevelStorage
 	}
 
 	@Override
-	public void saveLevelDataAndPlayerData(LevelData levelData, List<EntityPlayer> playerList)
+	public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
 	{
 		CompoundTag nbttagcompound = levelData.getNBTTagCompoundWithPlayer(playerList);
 		CompoundTag nbttagcompound1 = new CompoundTag();
diff --git a/src/main/java/net/minecraft/core/world/save/SaveHandlerClientMP.java b/src/main/java/net/minecraft/core/world/save/SaveHandlerClientMP.java
index 56454ca38..cc5a3778c 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveHandlerClientMP.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveHandlerClientMP.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.save;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
@@ -53,7 +53,7 @@ public class SaveHandlerClientMP
 	}
 
 	@Override
-	public void saveLevelDataAndPlayerData(LevelData levelData, List<EntityPlayer> playerList)
+	public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
 	{
 		
 	}
diff --git a/src/main/java/net/minecraft/core/world/save/SaveHandlerClientSP.java b/src/main/java/net/minecraft/core/world/save/SaveHandlerClientSP.java
index a202f2ab2..b345ef62e 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveHandlerClientSP.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveHandlerClientSP.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.world.save;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.chunk.ChunkLoaderRegionAsync;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.chunk.ChunkLoaderRegion;
 
 import java.io.File;
 import java.util.List;
@@ -28,7 +27,7 @@ public class SaveHandlerClientSP
     }
 
     @Override
-    public void saveLevelDataAndPlayerData(LevelData levelData, List<EntityPlayer> playerList)
+    public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
     {
         levelData.setSaveVersion(saveFormat.getSaveVersion());
         super.saveLevelDataAndPlayerData(levelData, playerList);
diff --git a/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java b/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
index 194be8eb5..e0e4995a5 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.save;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import com.mojang.nbt.NbtIo;
@@ -36,14 +36,14 @@ public class SaveHandlerServer
     }
 
     @Override
-    public void saveLevelDataAndPlayerData(LevelData levelData, List<EntityPlayer> playerList)
+    public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
     {
         levelData.setSaveVersion(saveFormat.getSaveVersion());
         super.saveLevelDataAndPlayerData(levelData, playerList);
     }
 
     @Override
-    public void save(EntityPlayer player)
+    public void save(Player player)
     {
         try
         {
@@ -65,7 +65,7 @@ public class SaveHandlerServer
     }
 
     @Override
-    public void load(EntityPlayer player)
+    public void load(Player player)
     {
         CompoundTag nbttagcompound = getPlayerData(player.username);
         if(nbttagcompound != null)
diff --git a/src/main/java/net/minecraft/core/world/save/conversion/ChunkConverter.java b/src/main/java/net/minecraft/core/world/save/conversion/ChunkConverter.java
index ff876a304..396ad1f6c 100644
--- a/src/main/java/net/minecraft/core/world/save/conversion/ChunkConverter.java
+++ b/src/main/java/net/minecraft/core/world/save/conversion/ChunkConverter.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.save.conversion;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 
 public class ChunkConverter
 {
@@ -229,7 +230,7 @@ public class ChunkConverter
 			converters[0].addMapping(new MappingSimple(52, 640)); //Block.mobspawner.blockID));
 			converters[0].addMapping(new MappingSimple(53, 160)); //Block.stairsPlanksOak.blockID));
 			converters[0].addMapping(new MappingSimple(54, 680)); //Block.chestPlanksOak.blockID));
-			converters[0].addMapping(new MappingSimple(55, 450)); //Block.wireRedstone.blockID));
+			converters[0].addMapping(new MappingSimple(55, 450)); //Blocks.WIRE_REDSTONE.blockID));
 			converters[0].addMapping(new MappingMetaToId(56, new int[] { 410, 411, 412, 413 })); //new int[] { Block.oreDiamondStone.blockID, Block.oreDiamondBasalt.blockID, Block.oreDiamondLimestone.blockID, Block.oreDiamondGranite.blockID }));
 			converters[0].addMapping(new MappingSimple(57, 435)); //Block.blockDiamond.blockID));
 			converters[0].addMapping(new MappingSimple(58, 650)); //Block.workbench.blockID));
diff --git a/src/main/java/net/minecraft/core/world/save/legacy/SaveFormatLegacy.java b/src/main/java/net/minecraft/core/world/save/legacy/SaveFormatLegacy.java
index f7417d550..9a22fee98 100644
--- a/src/main/java/net/minecraft/core/world/save/legacy/SaveFormatLegacy.java
+++ b/src/main/java/net/minecraft/core/world/save/legacy/SaveFormatLegacy.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.world.save.legacy;
 
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.save.IdKeyTable;
 import net.minecraft.core.world.save.SaveFormatBase;
 
 import java.io.File;
diff --git a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19132.java b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19132.java
index 35b34e90f..db1675d91 100644
--- a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19132.java
+++ b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19132.java
@@ -2,7 +2,6 @@ package net.minecraft.core.world.save.mcregion;
 
 
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.save.IdKeyTable;
 import net.minecraft.core.world.save.SaveFormatBase;
 
 import java.io.*;
diff --git a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19133.java b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19133.java
index 10f86a053..b0268709a 100644
--- a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19133.java
+++ b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19133.java
@@ -1,8 +1,6 @@
 package net.minecraft.core.world.save.mcregion;
 
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.save.IdKeyTable;
-import net.minecraft.core.world.save.IdKeyTableCustom;
 import net.minecraft.core.world.save.SaveFormatBase;
 
 import java.io.*;
diff --git a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19134.java b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19134.java
index f8f5a6908..18404166b 100644
--- a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19134.java
+++ b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19134.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.world.save.mcregion;
 
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.save.IdKeyTable;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.SaveFormatBase;
 
diff --git a/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java b/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
index 485472ce7..53dedd4d6 100644
--- a/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
+++ b/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
@@ -1,22 +1,24 @@
 package net.minecraft.core.world.saveddata.maps;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.saveddata.SavedData;
 
 import java.util.*;
 
 // Referenced classes of package net.minecraft.src:
-//            MapDataBase, NBTTagCompound, MapInfo, EntityPlayer, 
+//            MapDataBase, NBTTagCompound, MapInfo, Player,
 //            InventoryPlayer, MapCoord, ItemStack
 
 public class ItemMapSavedData extends SavedData
 {
+    public static final byte MAX_SCALE = 4;
     public int x;
     public int z;
     public byte dimension;
@@ -24,7 +26,7 @@ public class ItemMapSavedData extends SavedData
     public byte[] colors;
     public int step;
     public List<HoldingPlayer> carriedBy;
-    private final Map<EntityPlayer, HoldingPlayer> carriedByPlayers;
+    private final Map<Player, HoldingPlayer> carriedByPlayers;
     public List<MapDecoration> decorations;
     public final int MAX_WAYPOINTS = 16;
     public List<MapWaypoint> mapWaypoints;
@@ -50,9 +52,9 @@ public class ItemMapSavedData extends SavedData
         {
             scale = 0;
         }
-        if(scale > 4)
+        if(scale > MAX_SCALE)
         {
-            scale = 4;
+            scale = MAX_SCALE;
         }
         short width = tag.getShort("width");
         short height = tag.getShort("height");
@@ -106,7 +108,7 @@ public class ItemMapSavedData extends SavedData
         tag.put("Waypoints", waypointsList);
     }
 
-    public void tickCarriedBy(EntityPlayer player, ItemStack stack)
+    public void tickCarriedBy(Player player, ItemStack stack)
     {
         if(!carriedByPlayers.containsKey(player))
         {
@@ -118,7 +120,7 @@ public class ItemMapSavedData extends SavedData
 
         for(MapWaypoint mapWaypoint : mapWaypoints){
             if(player.distanceToSqr(mapWaypoint.xPos, mapWaypoint.yPos, mapWaypoint.zPos) <= 256D) {
-               if(player.world.getBlockId(mapWaypoint.xPos, mapWaypoint.yPos, mapWaypoint.zPos)!= Block.flag.id)
+               if(player.world.getBlockId(mapWaypoint.xPos, mapWaypoint.yPos, mapWaypoint.zPos)!= Blocks.FLAG.id)
                 {
                     mapWaypoints.remove(mapWaypoint);
                     break;
@@ -137,16 +139,12 @@ public class ItemMapSavedData extends SavedData
             }
             float f = (float)(mapinfo1.player.x - (double) x) / (float)(1 << scale);
             float f1 = (float)(mapinfo1.player.z - (double) z) / (float)(1 << scale);
-            int j = 64;
-            int k = 64;
-            if(f < (float)(-j) || f1 < (float)(-k) || f > (float)j || f1 > (float)k)
-            {
-                continue;
-            }
             byte color = 0;
-            byte xCoord = (byte)(int)((double)(f * 2.0F) + 0.5D);
-            byte zCoord = (byte)(int)((double)(f1 * 2.0F) + 0.5D);
-            byte rotation = (byte)(int)((double)((player.yRot * 16F) / 360F) + 0.5D);
+            byte xCoord = (byte)(MathHelper.clamp((double)(f * 2.0F) + 0.5D, -128, 127));
+            byte zCoord = (byte)(MathHelper.clamp((double)(f1 * 2.0F) + 0.5D, -128, 127));
+            float yRot = player.yRot;
+            while (yRot < 0) yRot += 360;
+            byte rotation = (byte)((double)((yRot * 16F) / 360F) + 0.5D);
             if(dimension == 1)
             {
                 int l = step / 10;
@@ -161,7 +159,7 @@ public class ItemMapSavedData extends SavedData
         }
     }
 
-    public boolean createNewWaypoint(TileEntityFlag flag)
+    public boolean createNewWaypoint(FlagBlockEntity flag)
     {
         if(mapWaypoints.size() >= MAX_WAYPOINTS)
             return false;
@@ -191,7 +189,7 @@ public class ItemMapSavedData extends SavedData
         return true;
     }
 
-    public byte[] getMapDataBytes(ItemStack stack, World world, EntityPlayer player)
+    public byte[] getMapDataBytes(ItemStack stack, World world, Player player)
     {
         HoldingPlayer mapinfo = carriedByPlayers.get(player);
         if(mapinfo == null)
@@ -254,14 +252,14 @@ public class ItemMapSavedData extends SavedData
 
     public class HoldingPlayer
     {
-        public final EntityPlayer player;
+        public final Player player;
         public int[] minDirty;
         public int[] maxDirty;
         private int tick;
         private int step;
         private byte[] packetBuffer;
 
-        public HoldingPlayer(EntityPlayer player)
+        public HoldingPlayer(Player player)
         {
             minDirty = new int[128];
             maxDirty = new int[128];
diff --git a/src/main/java/net/minecraft/core/world/season/Seasons.java b/src/main/java/net/minecraft/core/world/season/Seasons.java
index 9d709c3eb..a029095b6 100644
--- a/src/main/java/net/minecraft/core/world/season/Seasons.java
+++ b/src/main/java/net/minecraft/core/world/season/Seasons.java
@@ -5,18 +5,18 @@ import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
-import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
 
 public abstract class Seasons
 {
     private static final Map<String, Season> SEASONS_MAP = new HashMap<>();
     public final static Season NULL = register(new SeasonNull("null"));
-    public final static Season OVERWORLD_SPRING = register(new SeasonSpring("overworld.spring").allowWeather(Weather.overworldRain, 0.3f).allowWeather(Weather.overworldFog, 0.3f).setDayLength(0.5f).setCropGrowthFactor(1.5f).setGrowFlowers().setSaplingDropFactor(2f));
-    public final static Season OVERWORLD_SUMMER = register(new SeasonSummer("overworld.summer").allowWeather(Weather.overworldRain, 0.1f).allowWeather(Weather.overworldStorm, 0.1f).setDayLength(0.6f));
-    public final static Season OVERWORLD_FALL = register(new SeasonFall("overworld.fall").allowWeather(Weather.overworldRain, 0.2f).allowWeather(Weather.overworldStorm, 0.05f).allowWeather(Weather.overworldFog, 0.5f).setDayLength(0.5f).setSaplingDropFactor(0.5f));
-    public final static Season OVERWORLD_WINTER = register(new SeasonWinter("overworld.winter").allowWeather(Weather.overworldSnow, 0.5f).allowWeather(Weather.overworldFog, 0.25f).setLetWeatherCleanUpSnow(false).setDayLength(0.3f).setCropGrowthFactor(0.25f).setKillFlowers().setSaplingDropFactor(0.1f));
+    public final static Season OVERWORLD_SPRING = register(new SeasonSpring("overworld.spring").allowWeather(Weathers.OVERWORLD_RAIN, 0.3f).allowWeather(Weathers.OVERWORLD_FOG, 0.3f).setDayLength(0.5f).setCropGrowthFactor(1.5f).setGrowFlowers().setSaplingDropFactor(2f));
+    public final static Season OVERWORLD_SUMMER = register(new SeasonSummer("overworld.summer").allowWeather(Weathers.OVERWORLD_RAIN, 0.1f).allowWeather(Weathers.OVERWORLD_STORM, 0.1f).setDayLength(0.6f));
+    public final static Season OVERWORLD_FALL = register(new SeasonFall("overworld.fall").allowWeather(Weathers.OVERWORLD_RAIN, 0.2f).allowWeather(Weathers.OVERWORLD_STORM, 0.05f).allowWeather(Weathers.OVERWORLD_FOG, 0.5f).setDayLength(0.5f).setSaplingDropFactor(0.5f));
+    public final static Season OVERWORLD_WINTER = register(new SeasonWinter("overworld.winter").allowWeather(Weathers.OVERWORLD_SNOW, 0.5f).allowWeather(Weathers.OVERWORLD_FOG, 0.25f).setLetWeatherCleanUpSnow(false).setDayLength(0.3f).setCropGrowthFactor(0.25f).setKillFlowers().setSaplingDropFactor(0.1f));
     public final static Season OVERWORLD_HELL = register(new SeasonOverworldHell("overworld.hell"));
-    public final static Season OVERWORLD_WINTER_ENDLESS = register(new SeasonWinter("overworld.winter.endless").allowWeather(Weather.overworldWinterSnow, 1.0f).setLetWeatherCleanUpSnow(false).setDayLength(0.3f).setCropGrowthFactor(0.25f).setKillFlowers().setSaplingDropFactor(0.1f));
+    public final static Season OVERWORLD_WINTER_ENDLESS = register(new SeasonWinter("overworld.winter.endless").allowWeather(Weathers.OVERWORLD_WINTER_SNOW, 1.0f).setLetWeatherCleanUpSnow(false).setDayLength(0.3f).setCropGrowthFactor(0.25f).setKillFlowers().setSaplingDropFactor(0.1f));
     public final static Season PARADISE_GOLD = register(new SeasonParadiseGold("paradise.gold").setLetWeatherCleanUpSnow(false));
     public final static Season PARADISE_SILVER = register(new SeasonParadiseSilver("paradise.silver").setLetWeatherCleanUpSnow(false));
 
